//=========================================================
	DEVICE	ZXSPECTRUM128
	ORG	#6400
PROGBEG

BUFF	EQU	#E000

//------------------------------------------  , 
	LD	SP,#6400
	LD	BC,#7FFD
	LD	A,#17
	OUT	(C),A
//------------------------------------------   
	LD	HL,#5800
	LD	DE,#5801
	LD	BC,767
	LD	(HL),L
	LDIR
	LD	HL,#D800
	LD	DE,#D801
	LD	BC,767
	LD	(HL),L
	LDIR
//------------------------------------------  
HDR	EQU	#BD00
	LD	HL,HDR
	LD	DE,(23796)
	LD	BC,#0105
	CALL	#3D13	
//------------------------------------------  
	LD	HL,#4000	//6144
	LD	DE,(23796)
	LD	BC,#1805
	CALL	#3D13

	LD	HL,#C000	//6144
	LD	DE,(23796)
	LD	BC,#1805
	CALL	#3D13

	LD	HL,BUFF		//3072
	LD	DE,(23796)
	LD	BC,#0C05
	CALL	#3D13
	CALL	CALCA0

	LD	HL,BUFF		//3072
	LD	DE,(23796)
	LD	BC,#0C05
	CALL	#3D13
	CALL	CALCA1

	LD	HL,BUFF
	LD	DE,(23796)
	LD	BC,#0305	//768
	CALL	#3D13
	CALL	OUT8X8
	LD	BC,#7FFD
	LD	A,#17
	OUT	(C),A
//------------------------   
	DI
	LD	A,#BE
	LD	I,A
	IM	2
	LD	HL,#BE00
	LD	B,0
LL1	LD	(HL),#BF
	INC	HL
	DJNZ	LL1
	LD	(HL),#BF
	LD	HL,#BFBF
	LD	(HL),#C9
//------------------------
MAINLP	EI
	HALT
	LD	A,(HDR+5)
	OUT	(#FE),A
	CALL	PAUSE	;17
	CALL	ATTR0	;17
	EI
	HALT
	LD	A,(HDR+6)
	OUT	(#FE),A
	CALL	PAUSE
	CALL	ATTR1
	JP	MAINLP
//------------------------
PAUSE	LD	BC,#7FFD	;10
	LD	A,#1F		;7
PAGE	EQU	$-1		;
	XOR	%00001000	;7
	LD	(PAGE),A	;13 //37
	OUT	(C),A		;12
	//--------------
	LD	BC,735		;10 //745
PAUSE0	DEC	BC		;6
	LD	A,B		;4
	OR	C		;4
	JP	NZ,PAUSE0	;10 //24 - 17898+?/24
	//18
	DUP	5
	NOP
	EDUP
	RET			;10
//------------------------
OUT8X8
	LD	HL,BUFF
	LD	DE,#5800
	LD	A,24
	CALL	OUT1
	LD	DE,#D800
	LD	A,24
OUT1	//--------------
	DUP	8
	LDI
	EDUP
	EX	DE,HL
	LD	BC,16
	ADD	HL,BC
	EX	DE,HL
	DUP	8
	LDI
	EDUP
	DEC	A
	JP	NZ,OUT1
	RET
//------------------------
//	!DUP	8
//	LD	HL,data		;#21 #00 #00	/10
//	LD	(scr),HL	;#22 #00 #00	/16 //  26   
//	!EDUP			// 26*8=208 -> FREE16
//	NOP
//	NOP
//	NOP
//	NOP
CALCA0	LD	HL,ATTR0
	LD	DE,#5808
	JP	CA2
CALCA1	LD	HL,ATTR1
	LD	DE,#D808
CA2	LD	IX,BUFF
	LD	A,24
CA3	EX	AF,AF
	LD	C,8
CA1	LD	B,8
	PUSH	DE
CA0	LD	(HL),#21
	INC	HL
	LD	A,(IX)
	LD	(HL),A
	INC	HL
	INC	IX
	LD	A,(IX)
	LD	(HL),A
	INC	HL
	INC	IX
	LD	(HL),#22
	INC	HL
	LD	(HL),E
	INC	HL
	LD	(HL),D
	INC	HL
	INC	DE
	INC	DE
	DJNZ	CA0
	LD	(HL),#00
	INC	HL
	LD	(HL),#00
	INC	HL
	LD	(HL),#00
	INC	HL
	LD	(HL),#00
	INC	HL
	POP	DE
	DEC	C
	JP	NZ,CA1
	PUSH	HL
	LD	HL,32
	ADD	HL,DE
	EX	DE,HL
	POP	HL
	EX	AF,AF
	DEC	A
	JP	NZ,CA3
	LD	(HL),#C9
	RET


ATTR0	EQU	$
ATTR1	EQU	$+9985

ALLEND
//=========================================================
	LUA
	print (sj.get_label("ALLEND"))
	ENDLUA
//=========================================================
	EMPTYTRD "view8x1.trd"
	SAVETRD "view8x1.trd","CODE.C",PROGBEG,ALLEND-PROGBEG
//=========================================================
	ORG	#8000
BEGIMG	INCBIN	"image.mg1"
ENDIMG
	SAVETRD "view8x1.trd","IMAGE.C",BEGIMG,ENDIMG-BEGIMG
//---
	ORG	#8000
	INCBIN	"boot.bin"
	SAVETRD "view8x1.trd","boot.B",32768,256